<?php


require_once('include/upload_file.php');
require_once('include/formbase.php');

class Invoice extends Basic {
	var $new_schema = true;
	var $module_dir = 'Invoices';
	var $object_name = 'Invoice';
	var $table_name = 'invoices';
	var $importable = true;
	var $disable_row_level_security = true ; // to ensure that modules created and deployed under CE will continue to function under team security if the instance is upgraded to PRO
	var $id;
	var $name;
	var $date_entered;
	var $date_modified;
	var $modified_user_id;
	var $modified_by_name;
	var $created_by;
	var $created_by_name;
	var $description;
	var $deleted;
	var $created_by_link;
	var $modified_user_link;
	var $assigned_user_id;
	var $assigned_user_name;
	var $assigned_user_link;
	var $document_name;
	var $filename;
	var $file_ext;
	var $file_mime_type;
	var $uploadfile;
	var $active_date;
	var $exp_date;
	var $category_id;
	var $subcategory_id;
	var $status_id;
	var $status;
	var $invoice_status;
	var $amount;
	var $currency_id;	
	var $file_url;
	var $file_url_noimage;

	var $badFields = array(
		'account_description',
		'contact_id',
		'account_id',
		'lead_id',
		'opportunity_amount',
		'opportunity_id',
		'opportunity_name',
		'opportunity_role_id',
		'opportunity_role_fields',
		'opportunity_role',
		'campaign_id',
		'id',
		'modified_user_id',
		'modified_by_name',
		'created_by',
		'created_by_name',
		'date_entered',
		'date_modified',
		'items',
		'filename',
		'file_ext',
		'file_mime_type',
		'uploadfile',
		'currency_id',
		'amount',
		'date_paid',
		'invoice_source',
		'invoice_type',
		'tax_rate',
		'invoice_status',
		'document_id',
		'document_name',
	);
	
	

	function Invoices(){	
		parent::Basic();
	}
	
	function bean_implements($interface){
		switch($interface){
			case 'ACL': return true;
		}
		return false;		
	}

	function save($check_notify=false){
		if (!empty($this->uploadfile))
			$this->filename = $this->uploadfile;
		return parent::save($check_notify);		
 	}

	function fill_in_additional_detail_fields(){

		global $theme;
		global $current_language;
		global $timedate;
		global $app_list_strings;
		$this->uploadfile = $this->filename;
		$mod_strings = return_module_language($current_language, $this->object_name);
		global $img_name;
		global $img_name_bare;
		if (!$this->file_ext) {
			$img_name = SugarThemeRegistry::current()->getImageURL(strtolower($this->file_ext)."_image_inline.gif");
			$img_name_bare = strtolower($this->file_ext)."_image_inline";
		}
		//set default file name.
		if (!empty ($img_name) && file_exists($img_name)) {
			$img_name = $img_name_bare;
		} else {
			$img_name = "def_image_inline"; //todo change the default image.
		}
		$this->file_url_noimage = basename(UploadFile :: get_url($this->filename, $this->id));
		if(!empty($this->status_id)) {
	       $this->status = $app_list_strings['document_status_dom'][$this->status_id];
	    }
	    
	}



	function generateFieldDefsJS() {
		global $current_user;

		require_once("modules/Accounts/Account.php");

		$invoice = new Invoice();
		$account = new Account();


		$loopControl = array(
			'Invoices' => array(
			    'Invoices' => $invoice,
			),
			'Accounts' => array(
				'Accounts' => $account,
			),
		);

		$prefixes = array(
			'Invoices' => '',
			'Accounts' => 'account_',
		);

		$collection = array();
		foreach($loopControl as $collectionKey => $beans) {
			$collection[$collectionKey] = array();
			foreach($beans as $beankey => $bean) {

				foreach($bean->field_defs as $key => $field_def) {
				    if(	($field_def['type'] == 'relate' && empty($field_def['custom_type'])) ||
						($field_def['type'] == 'assigned_user_name' || $field_def['type'] =='link') ||
						($field_def['type'] == 'bool') ||
						(in_array($field_def['name'], $this->badFields)) ) {
				        continue;
				    }
				    if(!isset($field_def['vname'])) {
				    	//echo $key;
				    }
				    // valid def found, process
				    $optionKey = strtolower("{$prefixes[$collectionKey]}{$key}");
				    $optionLabel = preg_replace('/:$/', "", translate($field_def['vname'], $beankey));
				    $dup=1;
				    foreach ($collection[$collectionKey] as $value){
				    	if($value['name']==$optionKey){
				    		$dup=0;
				    		break;
				    	}
				    }
				    if($dup)
				        $collection[$collectionKey][] = array("name" => $optionKey, "value" => $optionLabel);
				}
			}
		}

		$json = getJSONobj();
		$ret = "var field_defs = ";
		$ret .= $json->encode($collection, false);
		$ret .= ";";
		return $ret;
	}
		
}
?>
