<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point'); 

require_once("modules/Invoices/InvoiceItems.php");
require_once("modules/Invoices/Invoice.php");
require_once('modules/Emails/Email.php');
require_once('modules/Notes/Note.php');

$focus = new Invoice();
$focus->retrieve($_REQUEST['record']);

if(!$focus->ACLAccess('View')){
	ACLController::displayNoAccess(true);
	sugar_cleanup(true);
}

$ii = new InvoiceItems($_REQUEST['record']);


if($focus->invoice_source == "Internal Editor"){
	$content = $ii->getPDF('I');
	$filename = $GLOBALS['mod_strings']['LBL_INVOICE'];
	$filename .= " ".$focus->invoice_number;
	$filename .= ".pdf";
}else{
	$content = file_get_contents($GLOBALS['sugar_config']['upload_dir']."".$focus->id);
	$filename = $focus->filename;
}
$filename = cleanFileName($filename);

$file_path = $GLOBALS['sugar_config']['upload_dir']."".$filename;
if(!file_put_contents($file_path,$content))
	die("Error occured. Please check premissions of the cache directory.");



$email = new Email();
$email->id = create_guid();
$email->new_with_id = true;
$email->name = $GLOBALS['mod_strings']['LBL_INVOICE']." ".$focus->invoice_number;
$email->description_html = $GLOBALS['mod_strings']['LBL_EMAIL_TEXT'];


$email->parent_type = "Accounts";
$email->parent_id = $focus->account_id;
$email->type = "draft";
$email->status = "draft";

if(isset($focus->account_id) && !empty($focus->account_id)){
	require_once('modules/Accounts/Account.php');
	$account = new Account();
	$account->retrieve($focus->account_id);            
     $email->load_relationship('accounts');
     $email->accounts->add($focus->account_id);
      
     if(!isset($focus->contact_id) || empty($focus->contact_id)){       
		$email->to_addrs_emails = $account->email1.";";
		$email->to_addrs = $focus->account_name." <".$account->email1.">";
	}	
}

if(isset($focus->contact_id) && !empty($focus->contact_id)){
	require_once('modules/Contacts/Contact.php');
	$contact = new Contact();
	$contact->retrieve($focus->contact_id);            
     $email->load_relationship('contacts');
     $email->contacts->add($focus->contact_id);
      
	$email->to_addrs_emails = $contact->email1.";";
	$email->to_addrs = $focus->contact_name." <".$contact->email1.">";		
}

$email->assigned_user_id = $GLOBALS['current_user']->id;
$email->date_start = $GLOBALS['timedate']->to_display_date_time(gmdate($GLOBALS['timedate']->get_db_date_time_format()));
$email->save(false);
$email_id = $email->id;   

$note = new Note();
$note->filename = $filename;
$note->file_mime_type = "application/pdf";
$note->name = $GLOBALS['mod_strings']['LBL_EMAIL_ATTACHMENT'].": ".$filename;
$note->parent_id = $email->id;
$note->parent_type = "Emails";
$note->save(false);
$note_id = $note->id;


if(!empty($note_id) && !empty($note_id)){
	if(!rename($GLOBALS['sugar_config']['upload_dir'].$filename, $GLOBALS['sugar_config']['upload_dir'].$note_id))
		die("File rename: error has been occured!");
	 header("Location: index.php?action=ComposeEmail&module=Invoices&parent_type=Accounts&return_module=Invoices&return_action=EditView&return_id=".$_REQUEST['record']."&recordId=$email_id"."&parent_id=".$focus->account_id."&invoice_id=".$_REQUEST['record']);

}else
	die("Error has been occured!");




?>
