<?php


$dictionary['Invoice'] = array(
	'table'=>'invoices',
	'audited'=>true,
	'fields'=>array (
	
	'invoice_number' =>
	  array (
	    'name' => 'invoice_number',
	    'vname' => 'LBL_INVOICE_NUMBER',
	    'type' => 'varchar',
	    'required'=> true,
	    'len' => '50',
	  ),
	  
	'filename' =>
	  array (
	    'name' => 'filename',
	    'vname' => 'LBL_FILENAME',
	    'type' => 'varchar',
	    'required'=> false,
	    'len' => '255',
	  ),
	  'file_ext' =>
	  array (
	    'name' => 'file_ext',
	    'vname' => 'LBL_FILE_EXTENSION',
	    'type' => 'varchar',
	    'len' => 100,
	  ),
	  'file_mime_type' =>
	  array (
	    'name' => 'file_mime_type',
	    'vname' => 'LBL_MIME',
	    'type' => 'varchar',
	    'len' => '100',
	  ),
	'uploadfile' =>
	  array (
		'name'=>'uploadfile',
		'vname' => 'LBL_FILENAME',
		'type' => 'file',
		'source' => 'non-db',
	  ),
	'publish_date' =>
	  array (
	    'name' => 'publish_date',
	    'vname' => 'LBL_PUBLISH_DATE',
	    'type' => 'date',
	    'importable' => 'required',
	    'display_default' => 'now',
	  ),
	'exp_date' =>
	  array (
	    'name' => 'exp_date',
	    'vname' => 'LBL_EXP_DATE',
	    'type' => 'date',
	  ),
	'date_paid' =>
	  array (
	    'name' => 'date_paid',
	    'vname' => 'LBL_DATE_PAID',
	    'type' => 'date',
	  ),
	  
	

    'account_invoices' =>
    array (
		'name' => 'account_invoices',
		'type' => 'link',
		'relationship' => 'account_invoices',
		'source' => 'non-db',
	),       
	'account_name' =>
	array (
		'name' => 'account_name',
		'rname' => 'name',
		'id_name' => 'account_id',
		'vname' => 'LBL_ACCOUNT_NAME',
		'type' => 'relate',
		'link' => 'account_invoices',
		'table' => 'accounts',
		'isnull' => 'true',
		'module' => 'Accounts',
		'source' => 'non-db',
	), 
	'account_id' => 
	array (
		'name' => 'account_id',
		'type' => 'id',
		'reportable' => false,
	),
	
    'contact_invoices' =>
    array (
		'name' => 'contact_invoices',
		'type' => 'link',
		'relationship' => 'contact_invoices',
		'source' => 'non-db',
	),       
	'contact_name' =>
	array (
		'name' => 'contact_name',
		'rname' => 'name',
		'id_name' => 'contact_id',
		'vname' => 'LBL_CONTACT_NAME',
		'type' => 'relate',
		'link' => 'contact_invoices',
		'table' => 'contacts',
		'isnull' => 'true',
		'module' => 'Contacts',
		'source' => 'non-db',
		'db_concat_fields' => 
		array (
			0 => 'first_name',
			1 => 'last_name',
		),
	), 
	'contact_id' => 
	array (
		'name' => 'contact_id',
		'type' => 'id',
		'reportable' => false,
	),


  'invoice_source' => 
  array (
    'name' => 'invoice_source',
    'vname' => 'LBL_INVOICE_SOURCE',
    'type' => 'enum',
    'massupdate' => '1',
    'default' => 'Internal Editor',
    'comments' => '',
    'help' => '',
    'importable' => 'true',
    'duplicate_merge' => 'disabled',
    'duplicate_merge_dom_value' => '0',
    'audited' => true,
    'reportable' => true,
    'len' => 100,
    'size' => '20',
    'options' => 'invoice_source_list',
    'studio' => 'visible',
    'dependency' => false,
  ),

  'invoice_type' => 
  array (
    'name' => 'invoice_type',
    'vname' => 'LBL_INVOICE_TYPE',
    'type' => 'enum',
    'massupdate' => '1',
    'default' => 'Item Price',
    'comments' => '',
    'help' => '',
    'importable' => 'true',
    'duplicate_merge' => 'disabled',
    'duplicate_merge_dom_value' => '0',
    'audited' => true,
    'reportable' => true,
    'len' => 100,
    'size' => '20',
    'options' => 'invoice_type_list',
    'studio' => 'visible',
    'dependency' => false,
  ),
	
  'invoice_status' => 
  array (
    'name' => 'invoice_status',
    'vname' => 'LBL_INVOICE_STATUS',
    'type' => 'enum',
    'massupdate' => '1',
    'default' => 'Open',
    'comments' => '',
    'help' => '',
    'importable' => 'true',
    'duplicate_merge' => 'disabled',
    'duplicate_merge_dom_value' => '0',
    'audited' => true,
    'reportable' => true,
    'len' => 100,
    'size' => '20',
    'options' => 'invoice_status_list',
    'studio' => 'visible',
    'dependency' => false,
  ),
  'amount' => 
  array (
    'name' => 'amount',
    'vname' => 'LBL_AMOUNT',
    'type' => 'currency',
    'massupdate' => 0,
    'comments' => '',
    'help' => '',
    'importable' => 'true',
    'duplicate_merge' => 'disabled',
    'duplicate_merge_dom_value' => '0',
    'audited' => true,
    'reportable' => true,
    'len' => 26,
    'size' => '20',
  ),
  'currency_id' => 
  array (
    'required' => false,
    'name' => 'currency_id',
    'vname' => 'LBL_CURRENCY',
    'type' => 'id',
    'massupdate' => 0,
    'comments' => '',
    'help' => '',
    'importable' => 'true',
    'duplicate_merge' => 'disabled',
    'duplicate_merge_dom_value' => 0,
    'audited' => false,
    'reportable' => true,
    'len' => 36,
    'size' => '20',
    'studio' => 'visible',
    'function' => 
    array (
      'name' => 'getCurrencyDropDown',
      'returns' => 'html',
    ),
  ),

  'document_name' => 
  array(
  	'name' => 'document_name',
  	'source' => 'non-db',
  	'type' => 'relate',
  ),
  'document_id' =>
  array(
	'name' => 'document_id',
	'type' => 'id',
	'size' => '36',
	'audited' => false,
	'importable' => false,	
  ),


  'items' =>
  array(
		'name' => 'items',
		'type' => 'text',
		'vname' => 'LBL_ITEMS',
  ),

  'tax_rate' =>
  array (
    'name' => 'tax_rate',
    'vname' => 'LBL_TAX_RATE',
    'type' => 'float',
    'dbType' => 'double',
    'audited'=>true,
    'validation' => array('type' => 'range', 'min' => 0, 'max' => 100),
    'merge_filter' => 'enabled', 
    'default' => 0,
  ),
  
  
),
	'relationships'=>array (
	),
	'indices' => array (
		array(
			'name' => 'idx_invoice',
			'type' => 'index',
			'fields' => array('name', 'invoice_number', 'deleted')
		),
	),
	'optimistic_locking'=>true,
);
if (!class_exists('VardefManager')){
        require_once('include/SugarObjects/VardefManager.php');
}
VardefManager::createVardef('Invoices','Invoice', array('basic','assignable'));
